﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MessageBox.Show(this, "Test 1: Checking cells [" + m_Spread_Sheet1.RowCount + " x " + m_Spread_Sheet1.ColumnCount + "] WITHOUT Tags" );

            DateTime start = DateTime.Now;

            for (int i = 0; i < m_Spread_Sheet1.RowCount; i++)
            {
                for (int j = 0; j < m_Spread_Sheet1.ColumnCount; j++)
                {
                    ValidateCell(i, j);
                }
                ValidateRow(i);
            }

            TimeSpan time = DateTime.Now - start;

            MessageBox.Show(this, "Test 1: Total time " + time.TotalSeconds);

            MessageBox.Show(this, "Test 2: Checking cells [" + m_Spread_Sheet1.RowCount + " x " + m_Spread_Sheet1.ColumnCount + "] WITH Tags");

            start = DateTime.Now;

            for (int i = 0; i < m_Spread_Sheet1.RowCount; i++)
            {
                for (int j = 0; j < m_Spread_Sheet1.ColumnCount; j++)
                    if (m_Spread_Sheet1.Cells[i, j].Tag == null)
                    {
                        ValidateCell(i, j);
                        m_Spread_Sheet1.Cells[i, j].Tag = "Valid";
                    }
                if (m_Spread_Sheet1.Rows[i].Tag == null)
                {
                    ValidateRow(i);
                    m_Spread_Sheet1.Rows[i].Tag = "Valid";
                }
            }

            time = DateTime.Now - start;

            MessageBox.Show(this, "Test 2: Total time " + time.TotalSeconds);
        }

        private void ValidateCell(int row, int column)
        {
            //Access element
            object value = m_Spread_Sheet1.Cells[row, column].Value;
            //Do something here
            return;
        }

        private void ValidateRow(int row)
        {
            //Access element
            bool visible = m_Spread_Sheet1.Rows[row].Visible;
            //Do something here
            return;
        }
    }
}
